#include <map>
#include "TCanvas.h"
#include "TPad.h"
#include "TLegend.h"
#include "TGraphErrors.h"
#include "TLine.h"
#include "TH1D.h"
#include "TFile.h"
#include <iostream>
#include "TROOT.h"
#include "math.h"
#include <fstream>
#include "TStyle.h"
#include "TPaveStats.h"
#include "TColor.h"
#include "TFractionFitter.h"
#include<sys/stat.h>
#include<sys/types.h>

int main()
{
   using namespace std;
  //=========Macro generated from canvas: c1/transparent pad
  //=========  (Wed Feb  4 16:17:30 2009) by ROOT version5.18/00
   
   //string hlt = "0"; //30
   //string hlt = "1"; //50
   //string hlt = "2"; //75
   string hlt = "3"; //90



   //create a directory here
   if(mkdir(("plotshlt"+hlt).c_str(),0777)==-1)//creating a directory
     {
       //cerr<<"Error :  "<<strerror(errno)<<endl;
       cerr<<"Error in creating directory" <<endl;
       //exit(1);
     }

   gStyle->SetErrorX(1);
   
   TFile *f1;
   TFile *f2; 
   TH1D  *hdata;
   TH1D  *hqcd;
   TH1D  *hphojet;
   TObjArray *mc = new TObjArray(2);        // MC histograms are put in this array
   TFractionFitter* fit;
   
   std::map<string,TCanvas*> c1;
   std::map<string,TLegend*> leg;
   
   
   TString filename1;
   TString filename2;
   //filename1 = "hlt_30.root"; ////data file name
   //filename1 = "hlt_60.root"; ////data file name
   //filename1 = "hlt_80.root"; ////data file name
   filename1 = "file_dR0.300000.root"; ////data file name
   //filename1 = "file_nodRcut.root"; ////data file name
   //filename1 = "file_dR0.500000.root"; ////data file name
   //filename1 = "file_dR1.000000.root"; ////data file name
   filename2 = "nopixelphojet.root";  //phojet file name
   string shistname;
   TString histname;
   TString datahistname;
   TString qcdhistname; //trkflip - > histos will go here
   TString fullhistname; //phojet
   
  

  char cxvariable[200];
  ifstream infile_xvar;
  infile_xvar.open("xvariables.list", ifstream::in );
  while(!infile_xvar.eof()){
    infile_xvar >>cxvariable;
    string xvariable(cxvariable);
    if(strncmp(cxvariable,"#",1)==0)
      {
	continue;
      }
    histname  = xvariable;
    shistname = histname; 
    datahistname = "datasigietahlt"+hlt+"_ptbin"+shistname; //data histos without trk flip
    fullhistname = "sigmaieta"+shistname; //phojet histos without trk flip
    qcdhistname  = "bkgsigietahlt"+hlt+"_ptbin"+shistname; //data histos with trkflip

    cout<<"datahistname = "<<datahistname<<endl;
    cout<<"fullhistname = "<<fullhistname<<endl;
    cout<<"qcdhistname = "<<qcdhistname<<endl; 

    c1[xvariable] = new TCanvas(("c"+xvariable).c_str(), "transparent pad",179,30,698,498);
    gStyle->SetOptStat(0);
    gStyle->SetPadGridX(3);
    gStyle->SetPadGridY(3);
    gStyle->SetGridStyle(3);
    c1[xvariable]->Range(0,0,1,1);
    c1[xvariable]->SetFillColor(0);
    c1[xvariable]->SetBorderMode(0);
    c1[xvariable]->SetBorderSize(2);
    c1[xvariable]->SetFrameFillStyle(0);
    c1[xvariable]->SetFrameBorderMode(0);
    
    //legend
    //leg[xvariable] = new TLegend(0.2,0.6,0.4,0.8);
    leg[xvariable] = new TLegend(0.4755043,0.5212766,0.8227666,0.8574468);
    leg[xvariable]->SetFillColor(0);
    //gPad->SetLogy(1);
    f1 = TFile::Open(filename1) ;
    f1->cd();

    hdata = (TH1D*)f1->Get(datahistname)->Clone();
    hqcd  = (TH1D*)f1->Get(qcdhistname)->Clone();
    //hqcd  = (TH1D*)f1->Get("tsigmaietaEE_eb100to120")->Clone();
    
    double integ_data = hdata->Integral();
    double integ_qcd = hqcd->Integral();
    cout<<"integ_data = "<<integ_data<<endl;
    cout<<"integ_qcd = "<<integ_qcd<<endl;

    //hqcd->Scale(integ_data/integ_qcd); 

    f2 = TFile::Open(filename2) ;
    f2->cd();
  
    TH1D *htemp = (TH1D*)f2->Get("sigmaietaEB_eb30to40")->Clone();
    int mynbins = htemp->GetNbinsX();
    double xlow = htemp->GetXaxis()->GetXmin();
    double xhigh = htemp->GetXaxis()->GetXmax();

    TH1D *hphojet = new TH1D("hphojet","signal",mynbins,xlow,xhigh);
    TH1D *hp1 = (TH1D*)f2->Get("sigmaietaEB_eb30to40")->Clone();
    TH1D *hp2 = (TH1D*)f2->Get("sigmaietaEB_eb40to50")->Clone();
    TH1D *hp3 = (TH1D*)f2->Get("sigmaietaEB_eb50to60")->Clone();
    TH1D *hp4 = (TH1D*)f2->Get("sigmaietaEB_eb60to70")->Clone();
    TH1D *hp5 = (TH1D*)f2->Get("sigmaietaEB_eb70to80")->Clone();
    TH1D *hp6 = (TH1D*)f2->Get("sigmaietaEB_eb80to100")->Clone();
    TH1D *hp7 = (TH1D*)f2->Get("sigmaietaEB_eb100to120")->Clone();
    TH1D *hp8 = (TH1D*)f2->Get("sigmaietaEB_eb120to160")->Clone();
    TH1D *hp9 = (TH1D*)f2->Get("sigmaietaEB_eb160to200")->Clone();
    TH1D *hp10 = (TH1D*)f2->Get("sigmaietaEB_eb200to250")->Clone();
    TH1D *hp11 = (TH1D*)f2->Get("sigmaietaEB_eb250to300")->Clone();

    hphojet->Add(hp1);
    hphojet->Add(hp2);
    hphojet->Add(hp3);
    hphojet->Add(hp4);
    hphojet->Add(hp5);
    hphojet->Add(hp6);
    hphojet->Add(hp7);
    hphojet->Add(hp8);
    hphojet->Add(hp9);
    hphojet->Add(hp10);
    hphojet->Add(hp11);

  //hphojet  = (TH1D*)f2->Get(fullhistname)->Clone();
    
    double integ_phojet = hphojet->Integral();
    cout<<"integ_phojet = "<<integ_phojet<<endl;

    //hphojet->Scale(integ_data/integ_phojet);
    int nbins = hphojet->GetNbinsX();
    cout<<"nbins = "<<nbins<<endl;
    
    ////try smoothening here
    //hphojet->Smooth(10);
    //hqcd->Smooth(10);
    //hphojet->Smooth(10);
    //hqcd->Smooth(9);
    //////////////////////

    //till this point I have defined all the three histos
    mc->Add(hqcd);
    mc->Add(hphojet);
    fit = new TFractionFitter(hdata, mc);    // initialise
    fit->Constrain(1,0.0,1.0);               // constrain fraction 1 to be between 0 and 1
    fit->SetRangeX(1,nbins);


    ////so that the fit happens
    if(integ_qcd>=25 && integ_data>=25){
      Int_t status = fit->Fit();               // perform the fit
      cout << "fit status: " << status << endl;
      if (status == 0) {                       // check on fit status
	TH1F* result = (TH1F*) fit->GetPlot();
	
	cout<<"RESULTS : "<<endl;
	double value1 = 0, error1 = 0;
	double value2 = 0, error2 = 0;
	
	fit-> GetResult(0,value1,error1);
	cout<<"qcd       = "<<value1<<endl;
	cout<<"qcd error = "<<error1<<endl;
	
	fit-> GetResult(1,value2,error2);
	cout<<"phojet       = "<<value2<<endl;
	cout<<"phojet error = "<<error2<<endl;
	
	double frac_qcd     = (value1*hdata->Integral());
	double frac_realpho = (value2*hdata->Integral());
	
	//scale MC template histos ot the frac.
	//qcd
	double ninteg_qcd = hqcd->Integral();
	hqcd->Scale(frac_qcd/ninteg_qcd);
	
	//phojet
	double ninteg_es = hphojet->Integral();
	hphojet->Scale(frac_realpho/ninteg_es);

	cout<<"bin corresponding ot 0.0105 : "<<hphojet->FindBin(0.0105)-1<<endl;
	//Now get the fraction of photons in 0.0105 range
	double frac_realpho_range013 = hphojet->Integral(0,21);
	double frac_qcd_range013     = hqcd->Integral(0,21);
	double data_range013         = hdata->Integral(0,21);
	
	/*//cout<<"====frac in range 0.013===="<<endl;
	cout<<"frac of real pho = "<<frac_realpho_range013/data_range013<<endl;
	cout<<"frac of qcd      = "<<frac_qcd_range013/data_range013<<endl;
	
	cout<<"fraction sum in whole range : "<<value1+value2<<endl;
	cout<<"total = frac_qcd_range013 + frac_realpho_range013 = "<<(frac_qcd_range013+frac_realpho_range013)/data_range013<<endl;
	*/
	
	///////till 9th nov, 2011                                                                                                                                     
	//cout<<"DONT USE THIS====frac in range 0.013===="<<endl;                                                                                                      
	cout<<"==========DONT USE THIS================="<<endl;
        cout<<"frac of real pho = "<<frac_realpho_range013/data_range013<<endl;
        cout<<"frac of qcd      = "<<frac_qcd_range013/data_range013<<endl;

	cout<<"fraction sum in whole range : "<<value1+value2<<endl;
        cout<<"total = frac_qcd_range013 + frac_realpho_range013 = "<<(frac_qcd_range013+frac_realpho_range013)/data_range013<<endl;
	cout<<"========================================="<<endl;

	//cout<<"USE THIS====frac in range 0.013===="<<endl;                                                                                                           
	cout<<"========== USE THIS================="<<endl;
	cout<<"frac of real pho = "<<frac_realpho_range013/(frac_realpho_range013+frac_qcd_range013)<<endl;
        cout<<"frac of qcd      = "<<frac_qcd_range013/(frac_realpho_range013+frac_qcd_range013)<<endl;

	cout<<"fraction sum in whole range : "<<value1+value2<<endl;
        cout<<"total = frac_qcd_range013 + frac_realpho_range013 = "<<(frac_qcd_range013+frac_realpho_range013)/(frac_qcd_range013+frac_realpho_range013)<<endl;
        cout<<"========================================="<<endl;


	double maxdata  = hdata->GetMaximum();
	double maxqcd   = hqcd->GetMaximum();
	double maxphojet = hphojet->GetMaximum();
	
	double max1 = TMath::Max(maxdata,maxqcd);
	double max  = TMath::Max(max1,maxphojet);
	
	hdata->SetMaximum(1.1*max);
	hqcd->SetMaximum(1.1*max);
	hphojet->SetMaximum(1.1*max);
	
	
	hdata->SetMarkerStyle(20);
	
	Int_t ci;   // for color index setting
	ci = 4;
	
	hqcd->SetLineColor(ci);
	hqcd->SetFillStyle(3005);
	hqcd->SetFillColor(ci);
	
	
	ci = 1;
	hphojet->SetLineColor(ci);
	hphojet->SetFillStyle(6);
	hphojet->SetFillColor(3);
	
	result->SetLineColor(2);
	result->SetLineWidth(2);
	c1[xvariable]->cd();
	hphojet->Draw();
	hqcd->Draw("same");
	hdata->Draw("PEsame");
	result->Draw("same");
	
	leg[xvariable]->AddEntry(hphojet,"fit to signal photons : #gamma+jet MC","f");
	leg[xvariable]->AddEntry(hqcd,"fit to fake photons : Data","f");
	leg[xvariable]->AddEntry(hdata,"Data","PE");
	leg[xvariable]->AddEntry(result,"fit to Data","l");
	
	leg[xvariable]->Draw();
	c1[xvariable]->Modified();
	c1[xvariable]->cd();
	c1[xvariable]->SetSelected(c1[xvariable]);
	c1[xvariable]->SaveAs(("plotshlt"+hlt+"/"+shistname+".gif").c_str());
	c1[xvariable]->SaveAs(("plotshlt"+hlt+"/"+shistname+".C").c_str());
	
	
    
      } //Fit Status
    }//if(integ_qcd>30 && integdata>30)
    
    else 
      {
	cout<<"!!!!!!!CANNOT FIT!!! integral < 25"<<endl;
	cout<<"take frac of real pho = 1 and QCD = 0"<<endl;
      }
    
    mc->Clear();
  
  } //Loop over xvariable.list lines
  
}//main() ends here


#ifdef __MAKECINT__                           
#pragma link C++ class map<string,TCanvas*>;
#pragma link C++ class map<string,TPad*>;
#pragma link C++ class map<string,TLegend*>;
#pragma link C++ class map<string,TGraphErrors*>;
#pragma link C++ class map<string,TLine*>;
#endif
